Imports Microsoft.VisualBasic 'for collection support

Public Class Form1

    Dim aNTFS As NTFSExplorer.NTFSDrive = Nothing

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        aNTFS = New NTFSExplorer.NTFSDrive("C")
        Dim alTemp As ArrayList = aNTFS.Errors
        If alTemp.Count > 0 Then
            Dim sTemp As String = ""
            For Each sError As String In alTemp
                sTemp = sTemp & sError & vbCrLf
                MsgBox(sTemp)
            Next
        Else
            MsgBox("No errors")
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        If Not (aNTFS Is Nothing) Then
            aNTFS.Activate()
        End If

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        TextBox1.Text = ""
        If Not (aNTFS Is Nothing) Then
            Dim recordnum As UInt64 = 5
            Dim MFR As NTFSExplorer.NTFSDrive.MFR
            MFR = aNTFS.GetMFTRecord(recordnum, &HFFFF) 'all attributes

            If (MFR Is Nothing) Then
                TextBox1.Text = TextBox1.Text & "MFR is nothing" & vbCrLf
                Exit Sub
            End If

            TextBox1.Text = TextBox1.Text & "NTFS Volume Info - Boot Sector" & vbCrLf
            TextBox1.Text = TextBox1.Text & aNTFS.BootSector.ToString(0)

            TextBox1.Text = TextBox1.Text & "NTFS Volume Info - BIOS Parameter Block Data" & vbCrLf
            TextBox1.Text = TextBox1.Text & aNTFS.BPD.ToString(0)

            TextBox1.Text = TextBox1.Text & "MFT Record Number " & recordnum & vbCrLf
            TextBox1.Text = TextBox1.Text & MFR.MFRHeader.ToString(0)

            For Each aAttribute As Object In MFR.colAttributes
                Dim aAttributeHeader As NTFSExplorer.NTFSDrive.AttributeHeader
                aAttributeHeader = aAttribute.AttributeHeader

                If aAttributeHeader.Description.StartsWith("$STANDARD_INFORMATION") Then
                    Dim aStandardInformation As NTFSExplorer.NTFSDrive.StandardInformation = aAttribute
                    TextBox1.Text = TextBox1.Text & aStandardInformation.ToString(0)
                End If

                If aAttributeHeader.Description.StartsWith("$FILE_NAME") Then
                    Dim aNameInformation As NTFSExplorer.NTFSDrive.NameInformation = aAttribute
                    TextBox1.Text = TextBox1.Text & aNameInformation.ToString(0)
                End If

                If aAttributeHeader.Description.StartsWith("$VOLUME_NAME") Then
                    Dim aVolumeNameInformation As NTFSExplorer.NTFSDrive.VolumeNameInformation = aAttribute
                    TextBox1.Text = TextBox1.Text & aVolumeNameInformation.ToString(0)
                End If

                If aAttributeHeader.Description.StartsWith("$VOLUME_INFORMATION") Then
                    Dim aVolumeInformation As NTFSExplorer.NTFSDrive.VolumeInformation = aAttribute
                    TextBox1.Text = TextBox1.Text & aVolumeInformation.ToString(0)
                End If

                If aAttributeHeader.Description.StartsWith("$DATA") Then
                    Dim aDataInformation As NTFSExplorer.NTFSDrive.DataInformation = aAttribute
                    TextBox1.Text = TextBox1.Text & aDataInformation.ToString(0)
                End If

                If aAttributeHeader.Description.StartsWith("$INDEX_ROOT") Then
                    Dim aRootIndexInformation As NTFSExplorer.NTFSDrive.RootIndexInformation = aAttribute
                    TextBox1.Text = TextBox1.Text & aRootIndexInformation.ToString(0, 5)
                End If

                If aAttributeHeader.Description.StartsWith("$INDEX_ALLOCATION") Then
                    Dim aIndexAllocation As NTFSExplorer.NTFSDrive.IndexAllocation = aAttribute
                    TextBox1.Text = TextBox1.Text & aIndexAllocation.ToString(0)
                End If

                If aAttributeHeader.Description.StartsWith("$BITMAP") Then
                    Dim aBitmapInformation As NTFSExplorer.NTFSDrive.BitmapInformation = aAttribute
                    TextBox1.Text = TextBox1.Text & aBitmapInformation.ToString(0)
                End If

                If aAttributeHeader.Description.StartsWith("$LOGGED_UTILITY_STREAM") Then
                    Dim aUtilityStreamInformation As NTFSExplorer.NTFSDrive.UtilityStreamInformation = aAttribute
                    TextBox1.Text = TextBox1.Text & aUtilityStreamInformation.ToString(0)
                End If


            Next

        End If

    End Sub
End Class
